From 52964f9665949c2219418a580b2b39d57e83fcc2 Mon Sep 17 00:00:00 2001
From: Aurélien Bompard <aurelien@bompard.org>
Date: Sep 28 2017 17:35:09 +0000
Subject: [PATCH 956/1001] The widget panel wrapper is handled in React


---

diff --git a/hubs/widgets/__init__.py b/hubs/widgets/__init__.py
index 76f17b0..be454bd 100644
--- a/hubs/widgets/__init__.py
+++ b/hubs/widgets/__init__.py
@@ -40,15 +40,10 @@ use of any Jinja2 feature, including inheritance, macros, etc.
 
 .. _Jinja2: http://jinja.pocoo.org/docs/
 
-If you want to add filters to youre widget's Jinja2 environment, you can do so
+If you want to add filters to your widget's Jinja2 environment, you can do so
 by overriding the widget's
 :py:meth:`~hubs.widgets.base.Widget.get_template_environment` method.
 
-Hubs provides the ``panel.html`` master template for widgets that want their
-output to be wrapped in the common panel chrome, just use the ``extends`` tag
-to take advantage of it.  You can also set a ``title`` variable in your root
-view context, and it will be used for the panel title.
-
 Refer to the API documentation to learn more on how to write a widget view.
 
 A widget can also have any number of cached functions.  A cached function is a
diff --git a/hubs/widgets/about/__init__.py b/hubs/widgets/about/__init__.py
index 0c01124..0da5c7b 100644
--- a/hubs/widgets/about/__init__.py
+++ b/hubs/widgets/about/__init__.py
@@ -23,6 +23,4 @@ class BaseView(RootWidgetView):
     def get_context(self, instance, *args, **kwargs):
         return dict(
             text=instance.config["text"],
-            title="<span class='glyphicon glyphicon-info-sign' "
-                  "aria-hidden='true'></span> About",
             )
diff --git a/hubs/widgets/badges/__init__.py b/hubs/widgets/badges/__init__.py
index f3e8f78..505d2b3 100644
--- a/hubs/widgets/badges/__init__.py
+++ b/hubs/widgets/badges/__init__.py
@@ -25,7 +25,7 @@ class Badges(Widget):
 class BaseView(RootWidgetView):
 
     def get_context(self, instance, *args, **kwargs):
-        context = {"title": self.widget.label}
+        context = {}
         get_badges = GetBadges(instance)
         context.update(get_badges())
         return context
diff --git a/hubs/widgets/base.py b/hubs/widgets/base.py
index 698f34d..2dad1a1 100644
--- a/hubs/widgets/base.py
+++ b/hubs/widgets/base.py
@@ -60,6 +60,7 @@ class Widget(object):
             URL-compatible characters.
         label (str): A humanized name for the widget, which will be shown in
             the UI.
+        display_css (str): A CSS class to use when displaying the widget.
         position (str): The position of the widget in the rendered page. It
             should be one of the following values: ``left``, ``right``, or
             ``both``.
@@ -71,14 +72,20 @@ class Widget(object):
         cached_functions_module (list): The Python path to the module where the
             cached functions must be looked for.  By default, they are looked
             for in the same module.
+        hidden_if_empty (bool): Set to True if the widget box should be
+            entirely hidden from the UI when no data is produced. As a
+            consequence, there will also be no progress spinner when the widget
+            is loading.
     """
 
     name = None
     label = None
+    display_css = None
     position = None
     parameters = []
     views_module = None
     cached_functions_module = None
+    hidden_if_empty = False
 
     def __init__(self):
         if self.name is None:
diff --git a/hubs/widgets/bugzilla/__init__.py b/hubs/widgets/bugzilla/__init__.py
index 363f7b2..a0643cc 100644
--- a/hubs/widgets/bugzilla/__init__.py
+++ b/hubs/widgets/bugzilla/__init__.py
@@ -39,7 +39,6 @@ class BaseView(RootWidgetView):
     def get_context(self, instance, *args, **kwargs):
         get_issues = GetIssues(instance)
         return dict(
-            title=self.widget.label,
             username=instance.config["username"],
             issues=get_issues()
             )
diff --git a/hubs/widgets/contact/__init__.py b/hubs/widgets/contact/__init__.py
index 288fc92..6992015 100644
--- a/hubs/widgets/contact/__init__.py
+++ b/hubs/widgets/contact/__init__.py
@@ -14,6 +14,7 @@ class Contact(Widget):
 
     name = "contact"
     position = "both"
+    display_title = None
 
 
 class BaseView(RootWidgetView):
diff --git a/hubs/widgets/dummy/__init__.py b/hubs/widgets/dummy/__init__.py
index d6733b7..c5e4f1d 100644
--- a/hubs/widgets/dummy/__init__.py
+++ b/hubs/widgets/dummy/__init__.py
@@ -22,6 +22,5 @@ class BaseView(RootWidgetView):
 
     def get_context(self, instance, *args, **kwargs):
         return dict(
-            title="This is a dummy widget",
             text=instance.config["text"],
             )
diff --git a/hubs/widgets/github_pr/__init__.py b/hubs/widgets/github_pr/__init__.py
index f52c149..a8b350a 100644
--- a/hubs/widgets/github_pr/__init__.py
+++ b/hubs/widgets/github_pr/__init__.py
@@ -43,7 +43,6 @@ class BaseView(RootWidgetView):
         context = dict(
             organization=org,
             display_number=instance.config["display_number"],
-            title=self.widget.label,
         )
         context.update(get_prs())
         return context
diff --git a/hubs/widgets/githubissues/__init__.py b/hubs/widgets/githubissues/__init__.py
index 0575545..fa0c996 100644
--- a/hubs/widgets/githubissues/__init__.py
+++ b/hubs/widgets/githubissues/__init__.py
@@ -43,7 +43,6 @@ class BaseView(RootWidgetView):
             org=instance.config["org"],
             repo=instance.config["repo"],
             display_number=instance.config["display_number"],
-            title=self.widget.label,
             all_issues=get_issues(),
         )
 
diff --git a/hubs/widgets/library/__init__.py b/hubs/widgets/library/__init__.py
index 3eddd2d..e8315d3 100644
--- a/hubs/widgets/library/__init__.py
+++ b/hubs/widgets/library/__init__.py
@@ -29,7 +29,4 @@ class BaseView(RootWidgetView):
             for u in instance.config.get('urls', '').split(',')
             if u.strip()
         ]
-        return dict(
-            title=self.widget.label,
-            urls=urls,
-            )
+        return dict(urls=urls)
diff --git a/hubs/widgets/linechart/__init__.py b/hubs/widgets/linechart/__init__.py
index 39b5be8..9fdccb2 100644
--- a/hubs/widgets/linechart/__init__.py
+++ b/hubs/widgets/linechart/__init__.py
@@ -38,7 +38,4 @@ class BaseView(RootWidgetView):
                "&user={username}&split_on=categories")
         url = url + "&" + categories
         url = url.format(username=username)
-        return dict(
-            title=self.widget.label,
-            url=url,
-            )
+        return dict(url=url)
diff --git a/hubs/widgets/meetings/__init__.py b/hubs/widgets/meetings/__init__.py
index 0633d40..9d8fc2e 100644
--- a/hubs/widgets/meetings/__init__.py
+++ b/hubs/widgets/meetings/__init__.py
@@ -49,7 +49,6 @@ class BaseView(RootWidgetView):
             if meeting['start_dt'] > now
             }
         return dict(
-            title=self.widget.label,
             calendar=instance.config["calendar"],
             meetings=meetings,
             )
diff --git a/hubs/widgets/memberships/__init__.py b/hubs/widgets/memberships/__init__.py
index ff57c74..78433b8 100644
--- a/hubs/widgets/memberships/__init__.py
+++ b/hubs/widgets/memberships/__init__.py
@@ -36,7 +36,6 @@ class BaseView(RootWidgetView):
         oldest_members = sorted(
             members, key=lambda m: m.get('created_on'))[:ELLIPSIS_LIMIT]
         return dict(
-            title=self.widget.label,
             memberships=list(members),
             oldest_members=list(oldest_members),
             )
diff --git a/hubs/widgets/pagure_pr/__init__.py b/hubs/widgets/pagure_pr/__init__.py
index 9346e54..4dc5562 100644
--- a/hubs/widgets/pagure_pr/__init__.py
+++ b/hubs/widgets/pagure_pr/__init__.py
@@ -30,7 +30,6 @@ class BaseView(RootWidgetView):
     def get_context(self, instance, *args, **kwargs):
         get_prs = GetPRs(instance)
         context = dict(
-            title=self.widget.label,
             repo=instance.config["repo"],
             )
         context.update(get_prs())
diff --git a/hubs/widgets/pagureissues/__init__.py b/hubs/widgets/pagureissues/__init__.py
index 3ba90d9..4cc033f 100644
--- a/hubs/widgets/pagureissues/__init__.py
+++ b/hubs/widgets/pagureissues/__init__.py
@@ -30,7 +30,6 @@ class BaseView(RootWidgetView):
     def get_context(self, instance, *args, **kwargs):
         get_issues = GetIssues(instance)
         context = dict(
-            title=self.widget.label,
             repo=instance.config["repo"],
             )
         context.update(get_issues())
diff --git a/hubs/widgets/sticky/__init__.py b/hubs/widgets/sticky/__init__.py
index f452d24..13c6af3 100644
--- a/hubs/widgets/sticky/__init__.py
+++ b/hubs/widgets/sticky/__init__.py
@@ -10,6 +10,7 @@ class Sticky(Widget):
     name = "sticky"
     label = "Sticky Note"
     position = "both"
+    display_css = "card-info"
     parameters = [
         dict(
             name="text",
@@ -26,6 +27,4 @@ class BaseView(RootWidgetView):
         # TODO -- render with markdown
         return dict(
             text=instance.config["text"],
-            title=self.widget.label,
-            panel_css_class="card-info",
             )
diff --git a/hubs/widgets/subscriptions/__init__.py b/hubs/widgets/subscriptions/__init__.py
index c3b9cb8..01a1f57 100644
--- a/hubs/widgets/subscriptions/__init__.py
+++ b/hubs/widgets/subscriptions/__init__.py
@@ -19,6 +19,8 @@ class Subscriptions(Widget):
 
     name = "subscriptions"
     position = "right"
+    display_title = "Hubs"
+    hidden_if_empty = True
     parameters = [
         dict(
             name="username",
@@ -32,7 +34,7 @@ class Subscriptions(Widget):
 class BaseView(RootWidgetView):
 
     def get_context(self, instance, *args, **kwargs):
-        context = dict(title="Hubs")
+        context = {}
         get_subs = GetSubs(instance)
         context.update(get_subs())
         return context
diff --git a/hubs/widgets/workflow/updates2stable.py b/hubs/widgets/workflow/updates2stable.py
index 25cc62d..9845cc4 100644
--- a/hubs/widgets/workflow/updates2stable.py
+++ b/hubs/widgets/workflow/updates2stable.py
@@ -18,6 +18,7 @@ class Updates2Stable(Widget):
     name = "workflow.updates2stable"
     label = 'Updates Ready for Stable'
     position = "right"
+    hidden_if_empty = True
     parameters = [
         dict(
             name="username",
@@ -35,7 +36,6 @@ class BaseView(RootWidgetView):
     def get_context(self, instance, *args, **kwargs):
         get_pending = GetPending(instance)
         context = dict(
-            title=self.widget.label,
             username=instance.config["username"],
             )
         context.update(get_pending())

